import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import java.util.*;

/**
 * Rg[NX.
 */
public class KCtrlPZL extends KCtrl implements KConstant {

	/**
	 * tF[Y.
	 */
	private final int PHASE_INIT		= 0;
	private final int PHASE_TITLE		= 1;
	private final int PHASE_STAGE_START	= 2;
	private final int PHASE_RUN			= 3;
	private final int PHASE_FAIL		= 4;
	private final int PHASE_END			= 5;
	private final int PHASE_STOP		= -1;

	/**
	 * x.
	 */
	private final int SPEED				= 16;

	/**
	 * ǉubNǉ܂ł̎.
	 */
	private final int TIME_ADD_BLOCK	= 2;

	/**
	 * Xe[W.
	 */
	private final int STAGE_STAR	= 5;

	/**
	 * C{[Xe[W.
	 */
	private final int STAGE_RAINBOW		= 7;

	/**
	 * ŏIXe[W.
	 */
	private final int STAGE_LAST		= 10;

	/**
	 * pl.
	 */
	private		KPanel				panel				= null;

	/**
	 * C[W.
	 */
	private		BufferedImage		imageBackground1	= null;
	private		BufferedImage		imageBackground2	= null;
	private		BufferedImage		imageBackground3	= null;
	private		BufferedImage		imageBlock00_01		= null;
	private		BufferedImage		imageBlock00_02		= null;
	private		BufferedImage		imageBlock00_03		= null;
	private		BufferedImage		imageBlock01		= null;
	private		BufferedImage		imageBlock02		= null;
	private		BufferedImage		imageBlock03		= null;
	private		BufferedImage		imageBlock04		= null;
	private		BufferedImage		imageBlock05		= null;
	private		BufferedImage		imageBlock06		= null;
	private		BufferedImage		imageBlock07		= null;
	private		BufferedImage		imageBlock08		= null;
	private		BufferedImage		imageBlock09		= null;
	private		BufferedImage		imageBlock10		= null;
	private		BufferedImage		imageBlock11		= null;
	private		BufferedImage		imageBlockAA		= null;
	private		BufferedImage		imageKakomuX		= null;
	private		BufferedImage		imageKakomuY		= null;
	private		BufferedImage		imageStar			= null;
	private		BufferedImage		imageGirl			= null;
	private		BufferedImage		imageRainbow		= null;
	private		BufferedImage		imageScore			= null;
	private		BufferedImage		imageLimit			= null;
	private		BufferedImage		imageBlockLimit		= null;
	private		BufferedImage		imageBlockScore		= null;

	/**
	 * XvCg.
	 * S̓Iɕ\XvCǵAŊǗB
	 */
	private		KSpriteBackground	spriteBackground	= null;

	/**
	 * ړpXvCgubN.
	 */
	private		KSpriteKakomuX		sprKakomuX			= null;
	private		KSpriteKakomuY		sprKakomuY			= null;

	/**
	 * XvCgubNꗗ.
	 */
	private		KSpriteBlock01[]	sprBrockStars		= null;

	/**
	 * XvCg.
	 */
	private		KSpriteStar			sprStar				= null;

	/**
	 * ̎qXvCg.
	 */
	private		KSpriteGirl			sprGirl				= null;

	/**
	 * C{[XvCgubNꗗ.
	 */
	private		KSpriteBlock01[]	sprBrockRainbows	= null;

	/**
	 * C{[XvCg.
	 */
	private		KSpriteRainbow		sprRainbow			= null;

	/**
	 * XRAXvCg.
	 */
	private		KSpriteScore		sprScore			= null;
	private		KSpriteBlockScore	sprBlockScore		= null;

	/**
	 * ԃXvCg.
	 */
	private		KSpriteLimit		sprLimit			= null;
	private		KSpriteBlockLimit	sprBlockLimit		= null;

	/**
	 * eLXg.
	 */
	private		KTextTitle			kTextTitle			= null;
	private		KText				kTextStart			= null;
	private		KText				kTextBy				= null;
	private		KText				kTextEnd			= null;
	private		KText				kTextScoreHigh		= null;
	private		KText				kTextScore			= null;
	private		KText				kTextStage			= null;
	private		KText				kTextLimit			= null;
	private		KText				kTextMessage		= null;

	/**
	 * XvCgubNꗗ.
	 */
	private		KSpriteBlock01[][]	sprBlocks			= new KSpriteBlock01[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];

	/**
	 * ǉubN.
	 */
	private		int[]				addBlocks			= new int[BLOCK_COL_COUNT];

	/**
	 * XvCgubNꗗ.
	 */
	private		ArrayList<KSpriteBlock01>	sprFallBlockLst		= new ArrayList<KSpriteBlock01>(100);

	/**
	 * 폜Ԉꗗ.
	 */
	private		ArrayList<String>		timeLst				= new ArrayList<String>();

	/**
	 * 폜XvCgubNꗗꗗ.
	 */
	private		ArrayList<ArrayList<KSpriteBlock01>>	deleteSprBlockLstLst		= new ArrayList<ArrayList<KSpriteBlock01>>();

	/**
	 * tF[Y.
	 */
	private		int					phase				= PHASE_INIT;

	/**
	 * XRA.
	 */
	private		int					score				= 0;

	/**
	 * nCXRA.
	 */
	private		int					scoreHigh			= 10000;

	/**
	 * Xe[W.
	 */
	private		int					stage				= 1;

	/**
	 * .
	 */
	private		int					time				= 0;

	/**
	 * .
	 */
	private		int					limit				= 0;

	/**
	 * ̐.
	 */
	private		int					countStar			= 0;

	/**
	 * C{[̐.
	 */
	private		int					countRainbow		= 0;

	/**
	 * }EXA_v^.
	 */
	private		KCPMouseAdapter		kcpMouseAdapter		= null;

	/**
	 * IłubNʒu.
	 */
	private		int					selectRow0			= -1;
	private		int					selectCol0			= -1;
	private		int					selectRow1			= -1;
	private		int					selectCol1			= -1;

	/**
	 * Ił}EXʒu.
	 */
	private		int					x0					= -1;
	private		int					y0					= -1;

	/**
	 * `FbNubNꗗ.
	 */
	private		ArrayList<KSpriteBlock01> checkLst = new ArrayList<KSpriteBlock01>();

	/**
	 * y.
	 */
	private		KSoundMidi				midiTitle		= null;
	private		KSoundMidi				midiGame		= null;
	private		KSoundMidi				midiHurryup		= null;

	private		KSoundWave				waveTitle		= null;
	private		KSoundWave				waveCredit		= null;
	private		KSoundWave				waveReady		= null;
	private		KSoundWave				waveGo			= null;
	private		KSoundWave				waveClick		= null;
	private		KSoundWave				waveDelete		= null;
	private		KSoundWave				waveStar		= null;
	private		KSoundWave				waveRainbow		= null;
	private		KSoundWave				waveHurryup		= null;
	private		KSoundWave				waveRoundup		= null;
	private		KSoundWave				wave100man		= null;
	private		KSoundWave				wave10man		= null;
	private		KSoundWave				waveFail		= null;
	private		KSoundWave				waveGameOver	= null;
	private		KSoundWave				waveKin			= null;

	/**
	 * RXgN^.
	 * @param con Rei
	 */
	public KCtrlPZL(Container con){

		super(con);

		try{

			// pl𐶐
			panel = new KPanel(this);

			// pl̃TCYݒ
			panel.setSize(KConstant.WIDTH, KConstant.HEIGHT);
			panel.setPreferredSize(new Dimension(KConstant.WIDTH, KConstant.HEIGHT));

			// XvCgw̐ݒ
			panel.setLayoutCount(LAYOUT_COUNT);

			// C[W擾
			imageBackground1 = KImage.getImage("image\\imageBackground1.jpg");
			imageBackground2 = KImage.getImage("image\\imageBackground2.jpg");
			imageBackground3 = KImage.getImage("image\\imageBackground3.jpg");
			imageBlock00_01 = KImage.getImage("image\\imageBlock00_01.gif");
			imageBlock00_02 = KImage.getImage("image\\imageBlock00_02.gif");
			imageBlock00_03 = KImage.getImage("image\\imageBlock00_03.gif");
			imageBlock01 = KImage.getImage("image\\imageBlock01.gif");
			imageBlock02 = KImage.getImage("image\\imageBlock02.gif");
			imageBlock03 = KImage.getImage("image\\imageBlock03.gif");
			imageBlock04 = KImage.getImage("image\\imageBlock04.gif");
			imageBlock05 = KImage.getImage("image\\imageBlock05.gif");
			imageBlock06 = KImage.getImage("image\\imageBlock06.gif");
			imageBlock07 = KImage.getImage("image\\imageBlock07.gif");
			imageBlock08 = KImage.getImage("image\\imageBlock08.gif");
			imageBlock09 = KImage.getImage("image\\imageBlock09.gif");
			imageBlock10 = KImage.getImage("image\\imageBlock10.gif");
			imageBlock11 = KImage.getImage("image\\imageBlock11.gif");
			imageBlockAA = KImage.getImage("image\\imageBlockAA.gif");
			imageKakomuX = KImage.getImage("image\\imageKakomuX.gif");
			imageKakomuY = KImage.getImage("image\\imageKakomuY.gif");
			imageStar = KImage.getImage("image\\imageStar.gif");
			imageGirl = KImage.getImage("image\\imageGirl.gif");
			imageRainbow = KImage.getImage("image\\imageRainbow.gif");
			imageScore = KImage.getImage("image\\imageScore.jpg");
			imageLimit = KImage.getImage("image\\imageLimit.jpg");
			imageBlockScore = KImage.getImage("image\\imageBlockScore.gif");
			imageBlockLimit = KImage.getImage("image\\imageBlockLimit.gif");

			// C[WXvCgɓo^
			KSpriteBackground.setImage(KSpriteBackground.class, new BufferedImage[]{imageBackground1, imageBackground2, imageBackground3});
			KSpriteBlock00.setImage(KSpriteBlock00.class, new BufferedImage[]{imageBlock00_01, imageBlock00_02, imageBlock00_03});
			KSpriteBlock01.setImage(KSpriteBlock01.class, new BufferedImage[]{imageBlock01, imageBlock02, imageBlock03, imageBlock04, imageBlock05,
																				imageBlock06, imageBlock07, imageBlock08, imageBlock09, imageBlock10,
																				imageBlock11});
			KSpriteBlockAA.setImage(KSpriteBlockAA.class, imageBlockAA);
			KSpriteKakomuX.setImage(KSpriteKakomuX.class, imageKakomuX);
			KSpriteKakomuY.setImage(KSpriteKakomuY.class, imageKakomuY);
			KSpriteStar.setImage(KSpriteStar.class, imageStar);
			KSpriteGirl.setImage(KSpriteGirl.class, imageGirl);
			KSpriteRainbow.setImage(KSpriteRainbow.class, imageRainbow);
			KSpriteScore.setImage(KSpriteScore.class, imageScore);
			KSpriteLimit.setImage(KSpriteLimit.class, imageLimit);
			KSpriteBlockScore.setImage(KSpriteBlockScore.class, imageBlockScore);
			KSpriteBlockLimit.setImage(KSpriteBlockLimit.class, imageBlockLimit);

			// wi
			spriteBackground = new KSpriteBackground(panel);

			//
			// eeLXg𐶐
			//

			kTextTitle = new KTextTitle(panel, 0, 0);

			kTextStart = new KText(panel, 176, 400);
			kTextStart.setFont(new Font("HGۺ޼M-PRO", Font.PLAIN, 16));
			kTextStart.setText("CLICK MOUSE BUTTON");

			kTextBy = new KText(panel, 200, 480);
			kTextBy.setFont(new Font("lr SVbN", Font.PLAIN, 12));
			kTextBy.setText("PROGRAMED  BY  KIN");

			kTextEnd = new KText(panel, 200, 100);
			kTextEnd.setFont(new Font("HGۺ޼M-PRO", Font.BOLD, 24));
			kTextEnd.setText("GAME OVER");

			kTextScoreHigh = new KText(panel, 50, 10);
			panel.addText("HIGH-SCORE", kTextScoreHigh);

			kTextScore = new KText(panel, 200, 10);
			panel.addText("SCORE", kTextScore);

			kTextStage = new KText(panel, 350, 10);
			panel.addText("STAGE", kTextStage);

			kTextLimit = new KText(panel, 350, 42);
			panel.addText("LIMIT", kTextLimit);

			kTextMessage = new KText(panel, 240, 100);
			kTextMessage.setFont(new Font("HGۺ޼M-PRO", Font.BOLD, 24));

			// 
			sprBrockStars = new KSpriteBlock01[COUNT_STAR];
			for(int i = 0; i < COUNT_STAR; i++){
				sprBrockStars[i] = new KSpriteBlock01(panel, STAGE_STAR);
				sprBrockStars[i].setY(this.getYSprBlock(BLOCK_ROW_COUNT));
				sprBrockStars[i].setX(this.getXSprBlock(-1) + 32 * i);
			}

			// C{[
			sprBrockRainbows = new KSpriteBlock01[COUNT_RAINBOW];
			for(int i = 0; i < COUNT_RAINBOW; i++){
				sprBrockRainbows[i] = new KSpriteBlock01(panel, STAGE_RAINBOW);
				sprBrockRainbows[i].setY(this.getYSprBlock(BLOCK_ROW_COUNT));
				sprBrockRainbows[i].setX(this.getXSprBlock(2) + 32 * i);
			}

			// ͂ރXvCg
			sprKakomuX = new KSpriteKakomuX(panel);
			sprKakomuY = new KSpriteKakomuY(panel);

			// XRA
			sprScore = new KSpriteScore(panel);
			sprBlockScore = new KSpriteBlockScore(panel);

			// Ԑ
			sprLimit = new KSpriteLimit(panel);
			sprBlockLimit = new KSpriteBlockLimit(panel);

			// ԃX^[g
			sprBlockLimit.start();

			// }EXA_v^
			kcpMouseAdapter = new KCPMouseAdapter();

			// }EXA_v^plɓo^
			panel.addMouseListener(kcpMouseAdapter);
			panel.addMouseMotionListener(kcpMouseAdapter);

			// yIuWFNg𐶐
			waveTitle = new KSoundWave(this, "sound\\Title.wav", false);
			waveCredit = new KSoundWave(this, "sound\\CREDIT_GameStart.WAV", false);
			waveReady = new KSoundWave(this, "sound\\Ready.WAV", false);
			waveGo = new KSoundWave(this, "sound\\Go.WAV", false);
			waveClick = new KSoundWave(this, "sound\\Click.WAV", false);
			waveDelete = new KSoundWave(this, "sound\\ERASE.WAV", false);
			waveStar = new KSoundWave(this, "sound\\STAR_RAINBOW2.wav", false);
			waveRainbow = new KSoundWave(this, "sound\\RainbowStar.wav", false);
			waveHurryup = new KSoundWave(this, "sound\\HurryUP.WAV", false);
			waveRoundup = new KSoundWave(this, "sound\\ROUNDUP.WAV", false);
			wave100man = new KSoundWave(this, "sound\\score100man.wav", false);
			wave10man = new KSoundWave(this, "sound\\score10man.wav", false);
			waveFail = new KSoundWave(this, "sound\\GAMEOVER_SE.WAV", false);
			waveGameOver = new KSoundWave(this, "sound\\GameOVER.wav", false);
			waveKin = new KSoundWave(this, "sound\\PresentedByKin.wav", false);

		// G[̏ꍇA
		}catch(Exception ex){
			// X^bNg[Xo
			ex.printStackTrace();
			// G[\
			JOptionPane.showMessageDialog(null, ex.toString());
		}

	} // end KCtrlPZL

	/**
	 * Jn.
	 * <pre>
	 * IuWFNg̏Jn܂B
	 * </pre>
	 */
	public void start(){

		// plɃtH[JX𓖂Ă
		panel.requestFocus();

		// plJn
		panel.start();

		// tF[Y
		this.phase = PHASE_INIT;

	} // end start

	/**
	 * s.
	 * <pre>
	 * IuWFNĝӂ܂肵܂B
	 * </pre>
	 */
	synchronized public void run(){

		// tF[Y
		switch(this.phase){

			// tF[Y
			case PHASE_INIT:

				// XRA
				score = 0;

				// Xe[W
				stage = 1;

				// ԏ
				time = 0;

				// ԏ
				limit = LIMIT_INIT;

				// ̐
				countStar = 0;

				// C{[̐
				countRainbow = 0;

				// ubÑXvCgw
				panel.initKSpriteLstInLayout(LAYOUT_SENTAKU);
				panel.initKSpriteLstInLayout(LAYOUT_BLK0);
				panel.initKSpriteLstInLayout(LAYOUT_BLK1);

				// wĩXvCgw
				panel.initKSpriteLstInLayout(LAYOUT_HAIKEI0);
				panel.initKSpriteLstInLayout(LAYOUT_HAIKEI1);
				panel.initKSpriteLstInLayout(LAYOUT_HAIKEI2);

				// XvCgO[v
				panel.initSpriteGroup();

				// XvCgubNꗗ.
				sprBlocks = new KSpriteBlock01[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];
				// ǉubN
				addBlocks = new int[BLOCK_COL_COUNT];
				// XvCgubNꗗ
				sprFallBlockLst		= new ArrayList<KSpriteBlock01>(100);
				// 폜Ԉꗗ
				timeLst				= new ArrayList<String>();
				// 폜XvCgubNꗗꗗ
				deleteSprBlockLstLst		= new ArrayList<ArrayList<KSpriteBlock01>>();
				// `FbNubNꗗ
				checkLst = new ArrayList<KSpriteBlock01>();

				// wio^
				panel.addSprite(LAYOUT_HAIKEI0, spriteBackground);

				// XRAo^
				panel.addSprite(LAYOUT_HAIKEI2, sprScore);

				// XRAݒ
				sprScore.setScore(time);

				// Ԃo^
				panel.addSprite(LAYOUT_HAIKEI2, sprLimit);

				// ԃX^[g
				sprBlockLimit.start();
				// ԃubNɐݒ
				sprBlockLimit.setHurryup(false);

				// XRAݒ
				// iƂ肠͌ȂԂɂj
				sprScore.setScore(0);

				// ^Cg\
				panel.addText("TITLE", kTextTitle);
				panel.addText("START", kTextStart);
				panel.addText("BY", kTextBy);

				// eeLXgŐV
				kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

				// XRA
				kTextScore.setText("SCORE : " + Integer.toString(score));

				// Xe[W
				kTextStage.setText("STAGE : " + Integer.toString(stage));

				// ԏ
				kTextLimit.setText("LIMIT : " + Integer.toString(limit / 60));

				// yIuWFNg𐶐
				midiTitle = new KSoundMidi(this, "sound\\PZL_Title.mid", true);
				midiGame = new KSoundMidi(this, "sound\\Pazz.MID", true);
				midiHurryup = new KSoundMidi(this, "sound\\Pazz_hurryup.MID", true);

				//
				// ǂ쐬
				//

				// c[v
				for(int row = 0; row < 17; row++){

					if(row != 1){
						KSpriteBlockAA kSpriteBlockAA = new KSpriteBlockAA(panel);
						panel.addSprite(LAYOUT_HAIKEI1, kSpriteBlockAA);
						kSpriteBlockAA.setY(row * 32);
					}else{
						panel.addSprite(LAYOUT_HAIKEI1, sprBlockLimit);
						sprBlockLimit.setY(row * 32);
					}

					if(row != 0){
						KSpriteBlockAA kSpriteBlockAA = new KSpriteBlockAA(panel);
						panel.addSprite(LAYOUT_HAIKEI1, kSpriteBlockAA);
						kSpriteBlockAA.setX(512);
						kSpriteBlockAA.setY(row * 32);
					}else{
						panel.addSprite(LAYOUT_HAIKEI1, sprBlockScore);
						sprBlockScore.setX(512);
						sprBlockScore.setY(row * 32);
					}

				} // ewd for c[v

				// [v
				for(int col = 0; col < 17; col++){

					KSpriteBlockAA kSpriteBlockAA = new KSpriteBlockAA(panel);
					panel.addSprite(LAYOUT_HAIKEI1, kSpriteBlockAA);
					kSpriteBlockAA.setX(col * 32);
					kSpriteBlockAA.setY(512);

				} // ewd for [v

				// yX^[g
				midiTitle.start();

				// ^Cg\tF[Y
				this.phase = PHASE_TITLE;

				break;

			// ^Cg\tF[Y
			case PHASE_TITLE:

				time++;

				// ^Cgn܂2bo
				if(time == 120){

					// 
					sprStar = new KSpriteStar(panel);

					// \
					panel.addSprite(LAYOUT_SENTAKU, sprStar);

					// ʉX^[g
					waveTitle.start();

				}

				break;

			// Xe[WJntF[Y
			case PHASE_STAGE_START:

				time++;

				// yX^[g
				if(time == 60){

					// ʉX^[g
					waveCredit.start();

				// READY
				}else if(time == 120){

					// ^Cg폜
					panel.removeText("TITLE");
					panel.removeText("START");
					panel.removeText("BY");

					// wiύX
					spriteBackground.setImage(0);

					// ubN
					initBlocks();

					// ꏊC
					kTextMessage.setX(216);

					// READY
					kTextMessage.setText("READY");

					// READY\
					panel.addText("MESSAGE", kTextMessage);

					// ʉX^[g
					waveReady.start();

				// GO!
				}else if(time == 240){

					// ꏊC
					kTextMessage.setX(240);

					// GO!
					kTextMessage.setText("GO!");

					// ʉX^[g
					waveGo.start();

				// {GO!
				}else if(time == 300){

					// GO!폜
					panel.removeText("MESSAGE");

					// yX^[g
					midiGame.start();

					// ԏ
					time = 0;

					// ʏtF[Y
					this.phase = PHASE_RUN;

				}

				break;

			// ʏtF[Y
			case PHASE_RUN:

				// Ԃi߂
				time++;

				//
				// ǉubN𗎉
				//

				// ԂꍇA
				if(time % TIME_ADD_BLOCK == 0){

					// 񐔕A[v
					for(int col = 0; col < BLOCK_COL_COUNT; col++){

						// ǉubNꍇA
						if(addBlocks[col] > 0){

							// ǉubNЂƂ炷
							addBlocks[col]--;

							// VubNF擾
							int block = getNewBlock();

							// XvCgubN
							KSpriteBlock01 sprFallBlock = new KSpriteBlock01(panel, block);

							// XYWݒ
							sprFallBlock.setX(col * 32 + 32);
							sprFallBlock.setY(-32);

							// XvCgubNꗗɒǉ
							sprFallBlockLst.add(sprFallBlock);

							// plɃubNǉ
							panel.addSprite(LAYOUT_BLK0, sprFallBlock);

						} // end if ǉubNꍇ

					} // 񐔕A[v

				} // end if Ԃꍇ

				//
				// ubN
				//

				// XvCgubNꗗ̌A[v
				for(int i = 0; i < sprFallBlockLst.size(); i++){

					// XvCgubN擾
					KSpriteBlock01 sprFallBlock = sprFallBlockLst.get(i);

					// XYW擾
					int y = sprFallBlock.getY();
					int x = sprFallBlock.getX();

					// 
					y = y + SPEED;

					// YWݒ
					sprFallBlock.setY(y);

					// ܂̂قŗ̏ꍇA
					if(y < POS_Y){
						// ReBj[
						continue;
					}

					// ̃ubN邩`FbNKvꍇA
					if(y % 32 != 0){
						// ReBj[
						continue;
					}

					// sʒu擾
					int row = getRow(y);
					int col = getCol(x);

					// ԉ܂ŗꍇA
					//   ܂́AubN̉ɃubNꍇ
					if(row == BLOCK_ROW_COUNT - 1 || sprBlocks[row + 1][col] != null){

						// XvCgubNꗗ폜
						sprFallBlockLst.remove(i);

						// [vЂƂ߂
						i--;

						// XvCgubNꗗɐݒ
						sprBlocks[row][col] = sprFallBlock;

						// `FbNubNꗗɓĂȂ΁A
						if(!checkLst.contains(sprFallBlock)){
							// `FbNubNꗗɒǉ
							this.checkLst.add(sprFallBlock);
							checkLst.add(sprFallBlock);
						}

					} // end if ubN̉ɃubNꍇ

				} // end for XvCgubNꗗ̌A[v

				//
				// `FbN
				//

				// XvCgubNSĖȂꍇA
				if(sprFallBlockLst.size() == 0){

					// `FbNA폜XvCgubNꗗ擾
					ArrayList<KSpriteBlock01> deleteSprBlockLst = check(checkLst);

					// 폜ubN擾łꍇA
					if(deleteSprBlockLst != null){

						// 폜Ԉꗗɒǉ
						timeLst.add("0");

						// 폜XvCgubNꗗꗗɒǉ
						deleteSprBlockLstLst.add(deleteSprBlockLst);

					} // end if 폜ubN擾łꍇ

					// `FbNubN
					this.checkLst.clear();

				} // end if `FbNKvȏꍇA

				//
				// 폜
				//

				// Ԉꗗ̌A[v
				for(int i = 0; i < timeLst.size(); i++){

					// Ԃ擾
					int time = Integer.parseInt(timeLst.get(i));

					// Ԃ{P
					time++;

					// Ԃݒ
					timeLst.set(i, String.valueOf(time));

					// 폜̂͂߂̎A
					if(time == 1){

						// ʉX^[g
						waveDelete.start();

					// C[WύXԂꍇA
					}else if(time == 10 || time == 20){

						int deleteStage = 0;
						if(time == 10){
							deleteStage = 1;
						}else{
							deleteStage = 2;
						}

						// 폜ꗗ擾
						ArrayList<KSpriteBlock01> deleteSprBlockLst = deleteSprBlockLstLst.get(i);

						// 폜ꗗ̌A[v
						for(int j = 0; j < deleteSprBlockLst.size(); j++){

							// 폜XvCgubN擾
							KSpriteBlock01 sprBlock = deleteSprBlockLst.get(j);

							// 폜iKݒ肷
							sprBlock.setDeleteStage(deleteStage);

						} // end for 폜ꗗ̌A[v

					// XvCg폜ԂꍇA
					}else if(time == 30){

						// 폜XvCgubNꗗ擾
						ArrayList<KSpriteBlock01> deleteSprBlockLst = deleteSprBlockLstLst.get(i);

						// 폜XvCgubNꗗ̌A[v
						for(int j = 0; j < deleteSprBlockLst.size(); j++){

							// 폜XvCgubN擾
							KSpriteBlock01 sprBlock = deleteSprBlockLst.get(j);

							// XvCg폜
							sprBlock.removeSprite();

							// XvCgubNꗗɓo^ĂꍇA
							if(sprFallBlockLst.indexOf(sprBlock) != -1){

								// XvCgubNꗗ폜
								sprFallBlockLst.remove(sprBlock);

							// XvCgubNꗗɓo^ĂȂꍇA
							// i~܂Ăꍇj
							}else{

								// \ʒu擾
								int y = sprBlock.getY();
								int x = sprBlock.getX();

								// sʒu擾
								int row = getRow(y);
								int col = getCol(x);

								// XvCgubNꗗ폜
								sprBlocks[row][col] = null;

								// ̃ubNA[v
								for(int row1 = row - 1; row1 >= 0; row1--){

									// XvCgubN擾
									sprBlock = sprBlocks[row1][col];

									// XvCgubN݂ꍇA
									if(sprBlock != null){

										// XvCgubNꗗ폜
										sprBlocks[row1][col] = null;

										// XvCgubNꗗɒǉ
										sprFallBlockLst.add(sprBlock);

										// `FbNubNꗗɊ܂܂ĂꍇA
										if(this.checkLst.contains(sprBlock)){
											// `FbNubNꗗ폜
											// ړn߂̂ŁA`FbNΏۂO
											this.checkLst.remove(sprBlock);
										}

									} // end if XvCgubN݂ꍇ

								} // end for ̃ubNA[v

							} // end if XvCgubNꗗɓo^ĂȂꍇ

						} // end for 폜XvCgubNꗗ̌A[v

						// 폜XvCgubNꗗ̌A[v
						for(int j = 0; j < deleteSprBlockLst.size(); j++){

							// 폜XvCgubN擾
							KSpriteBlock01 sprBlock = deleteSprBlockLst.get(j);

							// \ʒu擾
							int x = sprBlock.getX();

							// ǉubNꗗɒǉ
							addBlocks[getCol(x)]++;

							// XRAZ
							addScore(10);

						} // end for 폜XvCgubNꗗ̌A[v

						// Ԉꗗ폜
						timeLst.remove(i);

						// 폜XvCgubNꗗꗗ폜
						deleteSprBlockLstLst.remove(i);

						// [vЂƂ߂
						i--;

					} // end if XvCg폜Ԃꍇ

				} // end for Ԉꗗ̌A[v

				// ԌvZ
				limit--;

				// ԂOȏ̏ꍇA
				if(limit >= 0){

					// ԕ\
					kTextLimit.setText("LIMIT : " + Integer.toString(limit / 60));

					// Ԃݒ
					sprLimit.setLimit(limit);

					// Ԃ15bɂȂꍇA
					if(limit == 900){
						// yXgbv
						midiGame.stop();
						// tʒu
						midiHurryup.init();
						// ʉX^[g
						waveHurryup.start();
						// yX^[g
						midiHurryup.start();
						// ԃubNɐݒ
						sprBlockLimit.setHurryup(true);
					}

				// Ԃ}CiX̏ꍇA
				}else{

					// ԏ
					limit = 180;

					// yXgbv
					midiGame.stop();
					midiHurryup.stop();

					// ԃXvCgXgbv
					sprBlockLimit.stop();

					// stF[Y
					this.phase = PHASE_FAIL;

				} // end if Ԃ}CiX̏ꍇ

				break;

			// stF[Y
			case PHASE_FAIL:

				// ԌvZ
				limit--;

				// sĂ1b
				if(limit == 120){
					// ʉX^[g
					waveFail.start();
				}

				// Ԃ}CiX̏ꍇA
				if(limit < 0){

					// ԏ
					limit = 600;

					// Q[I[o[\
					panel.addText("GAME OVER", kTextEnd);

					// ʉX^[g
					waveGameOver.start();

					// Q[I[o[tF[Y
					this.phase = PHASE_END;

				} // end if Ԃ}CiX̏ꍇ

				break;

			// Q[I[o[tF[Y
			case PHASE_END:

				// ԌvZ
				limit--;

				// Q[I[o[̉yꂽA
				if(limit == 180){

					// ʉX^[g
					waveKin.start();

				// Ԃ}CiX̏ꍇA
				}else if(limit < 0){

					// Q[I[o[
					panel.removeText("GAME OVER");

					// tF[Y
					this.phase = PHASE_INIT;

				} // end if Ԃ}CiX̏ꍇ

				break;

			default:
				break;

		} // end switch tF[Y

	} // end run

	/**
	 * `FbN.
	 * <pre>
	 * 폜łubNꍇ́AArrayListԋp܂B
	 * 폜łubNȂꍇ́Anullԋp܂B
	 * </pre>
	 * @param checkLst `FbNubNꗗ
	 * @return ArrayList<KSpriteBlock01> 폜XvCgubNꗗ
	 */
	private ArrayList<KSpriteBlock01> check(ArrayList<KSpriteBlock01> checkLst){

		// 폜tO
		boolean flgDelete = false;

		// 폜ubNꗗ
		int[][] deleteBlocks = new int[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];

		// `FbNubNꗗ̌A[v
		for(int i = 0; i < checkLst.size(); i++){

			// `FbNubN擾
			KSpriteBlock01 sprBlock = checkLst.get(i);

			int row = getRow(sprBlock.getY());
			int col = getCol(sprBlock.getX());

			// Ƀ`FbNIĂꍇA
			if(deleteBlocks[row][col] != CHECK_NO_CHECK){
				// ReBj[
				continue;
			}

			// ɍ폜iKɂꍇA
			if(sprBlocks[row][col].getDeleteStage() != -1){
				// ReBj[
				continue;
			}

			// ubNF擾
			int color = sprBlocks[row][col].getColor();

			// 폜ꗗ
			ArrayList<int[]> deleteKohoLst	= new ArrayList<int[]>();

			// `FbN󋵈ꗗ
			int[][] checkedDeletes = new int[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];

			// `FbN󋵈ꗗɔfB폜ƂB
			checkedDeletes[row][col] = CHECK_DELETE;

			// 폜ꗗɒǉ
			deleteKohoLst.add(new int[]{row, col});

			// 폜ꗗ̌A[v
			for(int j = 0; j < deleteKohoLst.size(); j++){

				int row0 = deleteKohoLst.get(j)[0];
				int col0 = deleteKohoLst.get(j)[1];

				// Ƀ`FbNIĂꍇA
				if(deleteBlocks[row0][col0] != CHECK_NO_CHECK){
					// ReBj[
					continue;
				}

				// ɍ폜iKɂꍇA
				if(sprBlocks[row0][col0].getDeleteStage() != -1){
					// ReBj[
					continue;
				}

				// 

				// ԍł͂ȂꍇA
				if(col0 > 0){

					// ʒu
					int row1 = row0;
					int col1 = col0 - 1;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// ɍ폜iKɂꍇA
						}else if(sprBlocks[row1][col1].getDeleteStage() != -1){

							// `FbN󋵈ꗗɔfBcB
							// iƁAAʂ̂Ƃŏj
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԍł͂Ȃꍇ

				// E

				// ԉEł͂ȂꍇA
				if(col0 < BLOCK_COL_COUNT - 1){

					// ʒu
					int row1 = row0;
					int col1 = col0 + 1;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// ɍ폜iKɂꍇA
						}else if(sprBlocks[row1][col1].getDeleteStage() != -1){

							// `FbN󋵈ꗗɔfBcB
							// iƁAAʂ̂Ƃŏj
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԉEł͂Ȃꍇ

				// 

				// ԏł͂ȂꍇA
				if(row0 > 0){

					// ʒu
					int row1 = row0 - 1;
					int col1 = col0;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// ɍ폜iKɂꍇA
						}else if(sprBlocks[row1][col1].getDeleteStage() != -1){

							// `FbN󋵈ꗗɔfBcB
							// iƁAAʂ̂Ƃŏj
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԏł͂Ȃꍇ

				// 

				// ԉł͂ȂꍇA
				if(row0 < BLOCK_ROW_COUNT - 1){

					// ʒu
					int row1 = row0 + 1;
					int col1 = col0;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// ɍ폜iKɂꍇA
						}else if(sprBlocks[row1][col1].getDeleteStage() != -1){

							// `FbN󋵈ꗗɔfBcB
							// iƁAAʂ̂Ƃŏj
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԉł͂Ȃꍇ

			} // end for 폜ꗗ̌A[v

			// 폜ꗗRȏ̏ꍇA
			if(deleteKohoLst.size() >= 3){

				// ̏ꍇA
				if(color == STAGE_STAR){

					// ̐őł͂ȂꍇA
					if(countStar < COUNT_STAR){

						// \
						panel.addSprite(LAYOUT_SENTAKU, sprBrockStars[countStar]);

						// ̐ǉ
						countStar++;

					}

				// C{[̏ꍇA
				}else if(color == STAGE_RAINBOW){

					// C{[̐őł͂ȂꍇA
					if(countRainbow < COUNT_RAINBOW){

						// C{[\
						panel.addSprite(LAYOUT_SENTAKU, sprBrockRainbows[countRainbow]);

						// C{[̐ǉ
						countRainbow++;

					}

/*
					//
					// S
					//

					// 폜XvCgubNꗗ𐶐
					ArrayList<KSpriteBlock01> deleteSprBlockLst	= new ArrayList<KSpriteBlock01>();

					// s[v
					for(row = 0; row < BLOCK_ROW_COUNT; row++){

						// 񃋁[v
						for(col = 0; col < BLOCK_COL_COUNT; col++){

							// XvCgubN擾
							sprBlock = sprBlocks[row][col];

							// XvCgubN݂ȂꍇA
							// iȂꍇj
							if(sprBlock == null){
								// ReBj[
								continue;
							}

							// ɍ폜iKɂꍇA
							if(sprBlock.getDeleteStage() != -1){
								// ReBj[
								continue;
							}

							// 폜XvCgubNꗗɒǉ
							deleteSprBlockLst.add(sprBlock);

						} // end for 񃋁[v

					} // end for s[v

					// 폜XvCgubNꗗ^[
					return deleteSprBlockLst;
*/
				} // end if C{[̏ꍇ

				// 폜tO폜ɂ
				flgDelete = true;

				// 폜ꗗ̌A[v
				for(int j = 0; j < deleteKohoLst.size(); j++){

					// 폜擾
					row = deleteKohoLst.get(j)[0];
					col = deleteKohoLst.get(j)[1];

					// 폜ubNꗗɍ폜ݒ
					deleteBlocks[row][col] = CHECK_DELETE;

				} // end for 폜ꗗ̌A[v

			} // end if 폜ꗗRȏ̏ꍇ

		} // end for `FbNubNꗗ̌A[v

		// 폜̏ꍇA
		if(flgDelete){

			// 폜XvCgubNꗗ𐶐
			ArrayList<KSpriteBlock01> deleteSprBlockLst	= new ArrayList<KSpriteBlock01>();

			// s[v
			for(int row = 0; row < BLOCK_ROW_COUNT; row++){

				//  [v
				for(int col = 0; col < BLOCK_COL_COUNT; col++){

					// 폜̏ꍇA
					if(deleteBlocks[row][col] == CHECK_DELETE){

						// XvCgubN擾
						KSpriteBlock01 sprBlock = sprBlocks[row][col];

						// 폜XvCgubNꗗɒǉ
						deleteSprBlockLst.add(sprBlock);

						// 폜iKݒ
						sprBlock.setDeleteStage(0);

					} // end if 폜̏ꍇ

				} // end for 񃋁[v

			} // end for s[v

			// 폜XvCgubNꗗ^[
			return deleteSprBlockLst;

		} // end if 폜̏ꍇA

		// nullŃ^[
		return null;

	} // end check

	/**
	 * pl擾.
	 * @return KPanel pl
	 */
	public KPanel getKPanel(){

		// pl^[
		return this.panel;

	}

	/**
	 * }EXCxg.
	 * <pre>
	 * }EXCxgɂ鐧s܂B
	 * </pre>
	 * @param me }EXCxg
	 */
	synchronized public void mouseEvent(MouseEvent me){

		// tF[Y
		switch(this.phase){

			// ^CgʃtF[Y
			case PHASE_TITLE:

				// NbNȊOA
				if(me.getID() != MouseEvent.MOUSE_CLICKED){
					// ^[
					return;
				}

				// yXgbv
				midiTitle.stop();

				// Ԃ
				time = 0;

				// Xe[WJntF[Y
				phase = PHASE_STAGE_START;

				break;

			// ʏtF[Y
			case PHASE_RUN:

				// ^hbO^ȊO
				if(me.getID() != MouseEvent.MOUSE_PRESSED && me.getID() != MouseEvent.MOUSE_DRAGGED &&
								me.getID() != MouseEvent.MOUSE_RELEASED){
					// ^[
					return;
				}

				// A
				if(me.getID() == MouseEvent.MOUSE_PRESSED){

					// {^ȊȌꍇA
					if(me.getButton() != MouseEvent.BUTTON1){
						// ^[
						return;
					}

					// IłubNʒu
					this.selectRow0 = -1;
					this.selectCol0 = -1;

					// ꏊ擾
					int y = me.getY();
					int x = me.getX();

					// ubNʒu擾
					int row = getRow(y);
					int col = getCol(x);

					// ubN̏ꏊȊȌꍇ  ACesȊȌꍇA
					if((row < 0 || row >= BLOCK_ROW_COUNT ||
									col < 0 || col >= BLOCK_COL_COUNT) &&
									row != BLOCK_ROW_COUNT){
						// ^[
						return;
					}

					// IłubNʒuۑ
					this.selectRow0 = row;
					this.selectCol0 = col;

					// Ił}EXʒuۑ
					this.y0 = y;
					this.x0 = x;

				// hbOA
				}else if(me.getID() == MouseEvent.MOUSE_DRAGGED){

					// ̂ACes̏ꍇA
					if(selectRow0 == BLOCK_ROW_COUNT){
						// ^[
						return;
					}

					// ubNʒu
					this.selectRow1 = -1;
					this.selectCol1 = -1;

					// ݂͂U
					panel.removeSprite(LAYOUT_SENTAKU, sprKakomuY);
					panel.removeSprite(LAYOUT_SENTAKU, sprKakomuX);

					// ubNʒuۑĂȂꍇA
					if(this.selectRow0 == -1){
						// ^[
						return;
					}

					// ꏊ擾
					int y = me.getY();
					int x = me.getX();

					// ubNʒu擾
					int row = getRow(y);
					int col = getCol(x);

					// ړʁiΒljvZ
					int amountX = Math.abs(this.x0 - x);
					int amountY = Math.abs(this.y0 - y);

					// Xֈړ
					if(amountX >= amountY){

						// IłubNʒuƈꏏ̏ꍇA
						if(this.selectCol0 == col){
							// ^[
							return;
						}

						// ̏ꍇA
						if(this.selectCol0 > col){

							// IłubNʒuԍ̏ꍇA
							if(this.selectCol0 == 0){
								// ^[
								return;
							}

							// ͂
							sprKakomuX.setY(getYSprBlock(this.selectRow0));
							sprKakomuX.setX(getXSprBlock(this.selectCol0 - 1));
							panel.addSprite(LAYOUT_SENTAKU, sprKakomuX);

							// ubNʒu擾
							this.selectRow1 = this.selectRow0;
							this.selectCol1 = this.selectCol0 - 1;

						// ȄꍇA
						}else{

							// IłubNʒuԉȄꍇA
							if(this.selectCol0 >= BLOCK_COL_COUNT - 1){
								// ^[
								return;
							}

							// ͂
							sprKakomuX.setY(getYSprBlock(this.selectRow0));
							sprKakomuX.setX(getXSprBlock(this.selectCol0));
							panel.addSprite(LAYOUT_SENTAKU, sprKakomuX);

							// ubNʒu擾
							this.selectRow1 = this.selectRow0;
							this.selectCol1 = this.selectCol0 + 1;

						} // end if Ȅꍇ

					// Yֈړ
					}else{

						// IłubNʒuƈꏏ̏ꍇA
						if(this.selectRow0 == row){
							// ^[
							return;
						}

						// ̏ꍇA
						if(this.selectRow0 > row){

							// IłubNʒuԏ̏ꍇA
							if(this.selectRow0 == 0){
								// ^[
								return;
							}

							// ͂
							sprKakomuY.setY(getYSprBlock(this.selectRow0 - 1));
							sprKakomuY.setX(getXSprBlock(this.selectCol0));
							panel.addSprite(LAYOUT_SENTAKU, sprKakomuY);

							// ubNʒu擾
							this.selectRow1 = this.selectRow0 - 1;
							this.selectCol1 = this.selectCol0;

						// ̏ꍇA
						}else{

							// IłubNʒuԉ̏ꍇA
							if(this.selectRow0 >= BLOCK_ROW_COUNT - 1){
								// ^[
								return;
							}

							// ͂
							sprKakomuY.setY(getYSprBlock(this.selectRow0));
							sprKakomuY.setX(getXSprBlock(this.selectCol0));
							panel.addSprite(LAYOUT_SENTAKU, sprKakomuY);

							// ubNʒu擾
							this.selectRow1 = this.selectRow0 + 1;
							this.selectCol1 = this.selectCol0;

						} // end if ̏ꍇ

					} // end if Yֈړ

				// A
				}else if(me.getID() == MouseEvent.MOUSE_RELEASED){

					// {^ȊȌꍇA
					if(me.getButton() != MouseEvent.BUTTON1){
						// ^[
						return;
					}

					// ݂͂
					panel.removeSprite(LAYOUT_SENTAKU, sprKakomuY);
					panel.removeSprite(LAYOUT_SENTAKU, sprKakomuX);

					// ̂ACes̏ꍇA
					if(selectRow0 == BLOCK_ROW_COUNT){

						// ꏊ擾
						int y = me.getY();
						int x = me.getX();

						// ubNʒu擾
						int row = getRow(y);
						int col = getCol(x);

						// ̂Ɨs񂪈ꏏ̏ꍇ
						if(selectRow0 == row && selectCol0 == col){

							// ACe`FbN
							checkItem(col);

						}

						// ubNʒu
						this.selectRow0 = -1;
						this.selectCol0 = -1;
						this.selectRow1 = -1;
						this.selectCol1 = -1;

						// ^[
						return;
					}

					// ubNʒuۑĂȂꍇA
					if(this.selectRow0 == -1 || this.selectRow1 == -1){

						// ubNʒu
						this.selectRow0 = -1;
						this.selectCol0 = -1;
						this.selectRow1 = -1;
						this.selectCol1 = -1;

						// ^[
						return;
					}

					// IłubNʒuƈꏏ̏ꍇA
					if(this.selectRow0 == this.selectRow1 && this.selectCol0 == this.selectCol1){

						// ubNʒu
						this.selectRow0 = -1;
						this.selectCol0 = -1;
						this.selectRow1 = -1;
						this.selectCol1 = -1;

						// ^[
						return;
					}

					// XvCgubN擾
					KSpriteBlock01 sprBlock0 = sprBlocks[selectRow0][selectCol0];
					KSpriteBlock01 sprBlock1 = sprBlocks[selectRow1][selectCol1];

					// XvCgubN݂ȂꍇA
					if(sprBlock0 == null || sprBlock1 == null){
						// ^[
						return;
					}

					// łɍ폜̏ꍇA
					// xƁAȂ
					if(sprBlock0.getDeleteStage() != -1 || sprBlock1.getDeleteStage() != -1){
						// ^[
						return;
					}

					// łɃ`FbNubNꗗɊ܂܂ĂꍇA
					if(this.checkLst.contains(sprBlock0) || this.checkLst.contains(sprBlock1)){
						// ^[
						// ̃ubNŃ`FbN
						return;
					}

					// `FbNubNꗗ𐶐
					ArrayList<KSpriteBlock01> checkLst = new ArrayList<KSpriteBlock01>();

					// `FbNubNꗗɐݒ
					checkLst.add(sprBlock0);
					checkLst.add(sprBlock1);

					// ubN̔zuς
					blockChange(this.selectRow0, this.selectCol0, this.selectRow1, this.selectCol1);

					// ʉX^[g
					waveClick.start();

					// `FbN
					ArrayList<KSpriteBlock01> deleteSprBlockLst = check(checkLst);

					// 폜ꗗԋpĂꍇA
					if(deleteSprBlockLst != null){

						// Ԉꗗɒǉ
						timeLst.add("0");

						// 폜XvCgubNꗗꗗɒǉ
						deleteSprBlockLstLst.add(deleteSprBlockLst);

					// 폜ꗗԋpĂȂꍇA
					}else{

						// ubNɖ߂
						blockChange(this.selectRow0, this.selectCol0, this.selectRow1, this.selectCol1);

					} // end if 폜ꗗԋpĂȂꍇ

					// ubNʒu
					this.selectRow0 = -1;
					this.selectCol0 = -1;
					this.selectRow1 = -1;
					this.selectCol1 = -1;

				} // end if

				break;

			default:
				break;

		} // end switch tF[Y

	} // end mouseEvent

	/**
	 * ubN.
	 */
	private void initBlocks(){

		// s[v
		for(int row = 0; row < BLOCK_ROW_COUNT; row++){

			// 񃋁[v
			for(int col = 0; col < BLOCK_COL_COUNT; col++){

				// XvCgubN𐶐
				KSpriteBlock01 sprBlock =  new KSpriteBlock01(panel, getNewBlock());

				// XvCgubNꗗɐݒ
				sprBlocks[row][col] = sprBlock;

				// ubNʒuݒ
				sprBlock.setY(POS_Y + row * 32);
				sprBlock.setX(POS_X + col * 32);

				// plɃubNǉ
				panel.addSprite(LAYOUT_BLK0, sprBlock);

			} // end for 񃋁[v

		} // end for s[v

	} // end initBlocks

	/**
	 * VubNF擾.
	 * <pre>
	 * Xe[WlubNFԂ܂B
	 * </pre>
	 * @return int VubNF
	 */
	private int getNewBlock(){

		int color = (stage - 1) / 2 + 4;
		color = (color > 11)?11: color;

		return (int)(Math.random() * color);

	}

	/**
	 * XRAZ.
	 * <pre>
	 * XRAZꍇ́AĂяoĂB
	 * </pre>
	 * @param scoreAdd ǉ_
	 */
	public void addScore(int scoreAdd){

		// XRAZ
		this.score = this.score + scoreAdd;

		// XRA\
		kTextScore.setText("SCORE : " + Integer.toString(score));

		// XRAݒ
		sprScore.setScore(this.score);

		// nCXRAXVꂽꍇA
		if(this.score > this.scoreHigh){
		
			// nCXRAu
			this.scoreHigh = this.score;

			// nCXRA\
			kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

		} // end if nCXRAXVꂽꍇ

		// Xe[Wi߂ꍇA
		if(score > stage * 10000){

			// Ԃ
			limit = LIMIT_INIT;

			// Xe[Wi߂
			stage++;

			// Xe[W\
			kTextStage.setText("STAGE : " + Integer.toString(stage));

			// NAubNɃXe[WNA`
			sprBlockScore.clearStage();

			// Hurryupt̏ꍇA
			if(midiHurryup.isRunning()){

				// yXgbv
				midiHurryup.stop();
				// tʒu
				midiGame.init();
				// yX^[g
				midiGame.start();
				// ԃubNɐݒ
				sprBlockLimit.setHurryup(false);

			}

			// Xe[WȐꍇA
			if(stage == 3){

				// wiύX
				spriteBackground.setImage(1);

				// eLXg̐FύX
				kTextScoreHigh.setForeground(Color.black);
				kTextScore.setForeground(Color.black);
				kTextStage.setForeground(Color.black);
				kTextLimit.setForeground(Color.black);
				kTextMessage.setForeground(Color.black);
				sprBlockLimit.setForeground(new Color(192, 192, 255));

			// Xe[WT̏ꍇA
			}else if(stage == 5){

				// wiύX
				spriteBackground.setImage(2);

				// eLXg̐FύX
				kTextScoreHigh.setForeground(Color.white);
				kTextScore.setForeground(Color.white);
				kTextStage.setForeground(Color.white);
				kTextLimit.setForeground(Color.white);
				kTextMessage.setForeground(Color.white);
				sprBlockLimit.setForeground(Color.white);

			} // end if Xe[WT̏ꍇ

			// 100_Pʂ̏ꍇA
			if((score / 10000) % 100 == 0){

				// ʉX^[g
				wave100man.start();

			// 10_Pʂ̏ꍇA
			}else if((score / 10000) % 10 == 0){

				// ʉX^[g
				wave10man.start();

			// ̓_̏ꍇA
			}else{

				// ʉX^[g
				waveRoundup.start();

			} // end if

		} // end ifXe[Wi߂ꍇ

	} // end addScore

	/**
	 * sʒu擾.
	 * <pre>
	 * pl̈ʒuYsʒu擾܂B
	 * ubNʒuł͂ȂĂAzIȈʒuԂ܂B
	 * </pre>
	 * @param y ʒuY
	 * @return int sʒu
	 */
	private int getRow(int y){

		// sʒu^[
		return (y - POS_Y) / 32;

	} // end getRow

	/**
	 * ʒu擾.
	 * <pre>
	 * pl̈ʒuXʒu擾܂B
	 * ubNʒuł͂ȂĂAzIȈʒuԂ܂B
	 * </pre>
	 * @param x ʒuX
	 * @return int ʒu
	 */
	private int getCol(int x){

		// ʒu^[
		if(x < 32){
			return -1;
		}
		return (x - POS_X) / 32;

	} // end getCol

	/**
	 * XvCgubNʒuY擾.
	 * <pre>
	 * sʒupl̈ʒuY擾܂B
	 * </pre>
	 * @param row sʒu
	 * @return int ʒuY
	 */
	private int getYSprBlock(int row){

		// ubNʒu^[
		return POS_Y + row * 32;

	} // end getYSprBlock

	/**
	 * XvCgubNʒuX擾.
	 * <pre>
	 * ʒupl̈ʒuX擾܂B
	 * </pre>
	 * @param col ʒu
	 * @return int ʒuX
	 */
	private int getXSprBlock(int col){

		// ubNʒu^[
		return POS_X + col * 32;

	} // end getXSprBlock

	/**
	 * ubNւ.
	 */
	private void blockChange(int row0, int col0, int row1, int col1){

		// XvCgʒuύX
		KSpriteBlock01 sprBlock = sprBlocks[row0][col0];
		sprBlocks[row0][col0] = sprBlocks[row1][col1];
		sprBlocks[row1][col1] = sprBlock;

		// XvCgWύX
		int x = sprBlocks[row0][col0].getX();
		sprBlocks[row0][col0].setX(sprBlocks[row1][col1].getX());
		sprBlocks[row1][col1].setX(x);

		int y = sprBlocks[row0][col0].getY();
		sprBlocks[row0][col0].setY(sprBlocks[row1][col1].getY());
		sprBlocks[row1][col1].setY(y);

	} // end blockChange

	/**
	 * ACe`FbN.
	 * @param col 
	 */
	private void checkItem(int col){

		// ␳
		col++;

		// 񂪐̏ꍇA
		if(col < COUNT_STAR){

			// ݂ꍇA
			if(col < countStar){

				// 炷
				countStar--;

				// XvCg폜
				sprBrockStars[countStar].removeSprite();

				// 
				sprStar = new KSpriteStar(panel);

				// \
				panel.addSprite(LAYOUT_SENTAKU, sprStar);

				// 30̊m
				if(Math.random() < 0.3f){

					// ̎q
					sprGirl = new KSpriteGirl(panel);

					// ̎q\
					panel.addSprite(LAYOUT_SENTAKU, sprGirl);

				}

				// ʉX^[g
				waveStar.start();

				// 폜XvCgubNꗗ𐶐
				ArrayList<KSpriteBlock01> deleteSprBlockLst	= new ArrayList<KSpriteBlock01>();

				// s[v
				for(int row = 0; row < BLOCK_ROW_COUNT; row++){

					// 񃋁[v
					for(col = 14 - row * 2; col < 22 - row * 2; col++){

						// 폜łȂꍇA
						if(col < 0 || col >= BLOCK_COL_COUNT){
							// ReBj[
							continue;
						}

						// XvCgubN擾
						KSpriteBlock01 sprBlock = sprBlocks[row][col];

						// XvCgubN݂ȂꍇA
						// iȂꍇj
						if(sprBlock == null){
							// ReBj[
							continue;
						}

						// ɍ폜iKɂꍇA
						if(sprBlock.getDeleteStage() != -1){
							// ReBj[
							continue;
						}

						// 폜iKݒ
						sprBlock.setDeleteStage(0);

						// 폜XvCgubNꗗɒǉ
						deleteSprBlockLst.add(sprBlock);

					} // end for 񃋁[v

				} // end for s[v

				// 폜Ԉꗗɒǉ
				timeLst.add("0");

				// 폜XvCgubNꗗꗗɒǉ
				deleteSprBlockLstLst.add(deleteSprBlockLst);

			} // end if ݂ꍇ

		// 񂪃C{[̏ꍇA
		}else if(col < COUNT_STAR + COUNT_RAINBOW){

			// ␳
			col = col - COUNT_STAR;

			// C{[݂ꍇA
			if(col < countRainbow){

				// C{[炷
				countRainbow--;

				// XvCg폜
				sprBrockRainbows[countRainbow].removeSprite();

				// C{[
				sprRainbow = new KSpriteRainbow(panel);

				// C{[\
				panel.addSprite(LAYOUT_SENTAKU, sprRainbow);

				// ʉX^[g
				waveRainbow.start();

				// 폜XvCgubNꗗ𐶐
				ArrayList<KSpriteBlock01> deleteSprBlockLst	= new ArrayList<KSpriteBlock01>();

				// s[v
				for(int row = 0; row < BLOCK_ROW_COUNT; row++){

					// 񃋁[v
					for(col = 0; col < BLOCK_COL_COUNT; col++){

						// XvCgubN擾
						KSpriteBlock01 sprBlock = sprBlocks[row][col];

						// XvCgubN݂ȂꍇA
						// iȂꍇj
						if(sprBlock == null){
							// ReBj[
							continue;
						}

						// ɍ폜iKɂꍇA
						if(sprBlock.getDeleteStage() != -1){
							// ReBj[
							continue;
						}

						// 폜iKݒ
						sprBlock.setDeleteStage(0);

						// 폜XvCgubNꗗɒǉ
						deleteSprBlockLst.add(sprBlock);

					} // end for 񃋁[v

				} // end for s[v

				// 폜Ԉꗗɒǉ
				timeLst.add("0");

				// 폜XvCgubNꗗꗗɒǉ
				deleteSprBlockLstLst.add(deleteSprBlockLst);

			} // end if C{[݂ꍇ

		} // end if 񂪃C{[̏ꍇ

	} // end checkItem

	/**
	 * }EXCxg.
	 */
	private class KCPMouseAdapter extends MouseAdapter {

		/**
		 * }EXNbN.
		 */
		public void mouseClicked(MouseEvent me){

			// X[p[NXĂяo
			super.mouseClicked(me);

			// }EXCxgĂяo
			KCtrlPZL.this.mouseEvent(me);

		} // end mouseClicked

		/**
		 * }EXꂽ.
		 */
		public void mousePressed(MouseEvent me){

			// X[p[NXĂяo
//			super.mousePressed(me);

			// }EXCxgĂяo
			KCtrlPZL.this.mouseEvent(me);

		} // end mousePressed

		/**
		 * }EXꂽ.
		 */
		public void mouseReleased(MouseEvent me){

			// X[p[NXĂяo
//			super.mouseReleased(me);

			// }EXCxgĂяo
			KCtrlPZL.this.mouseEvent(me);

		} // end mouseReleased

		/**
		 * hbOꂽ.
		 */
		public void mouseDragged(MouseEvent me){

			// X[p[NXĂяo
//			super.mouseDragged(me);

			// }EXCxgĂяo
			KCtrlPZL.this.mouseEvent(me);

		} // end mouseDragged

	} // end KCPMouseAdapter

}
